﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using SSAS = Microsoft.AnalysisServices;
using ADOMD = Microsoft.AnalysisServices.AdomdClient;
using System.IO;


namespace MeasuresDokumentation
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            SSAS.Server server = new SSAS.Server();
            SSAS.Database db;
            SSAS.Cube cb;

            _erg.Text = "";
            try
            {
                _erg.Text    = "connecting ...";
                Application.DoEvents();
                server.Connect("Data source=" + _server.Text);
                db = server.Databases.FindByName(_database.Text);
                cb = db.Cubes.FindByName(_cube.Text);
                _erg.Text = "connected" +Environment.NewLine+ _erg.Text;
                foreach (SSAS.Measure m in cb.AllMeasures)
                {
                    Application.DoEvents();
                    _erg.Text = "Measuregroup: " + m.Parent.Name + " Displayfolder:" + m.DisplayFolder + " Name:" +  m.Name + Environment.NewLine + _erg.Text;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Fehler: " + ex.Message);
            }
        }

        private void _btn_ADOMD_Click(object sender, EventArgs e)
        {
            _erg.Text = "connecting...";
            Application.DoEvents();
            ADOMD.AdomdConnection conn = new ADOMD.AdomdConnection("Data Source=" + _server.Text + ";Catalog=" + _database.Text);
            conn.Open();
            _erg.Text = "connected" + Environment.NewLine + _erg.Text;

            ADOMD.CubeDef c;// = getCube(_cube.Text, conn);

            c = conn.Cubes.Find(_cube.Text);

            TextWriter tw = new StreamWriter(_ergebnisdatei.Text, false, Encoding.Unicode);
            tw.WriteLine("Measuregroup;Displayfolder;Name;Description;sichtbar;Typ");

            foreach (ADOMD.Measure m in c.Measures)
            {
                Application.DoEvents();
                string measuregruppe = "";
                if (m.Properties["MEASUREGROUP_NAME"].Value == null)
                    measuregruppe = "<keine>";
                else
                    measuregruppe = m.Properties["MEASUREGROUP_NAME"].Value.ToString();

                string zeile = measuregruppe + ";" + m.DisplayFolder + ";" + m.Caption + ";" + m.Properties["DESCRIPTION"].Value.ToString() + ";" + m.Properties["MEASURE_IS_VISIBLE"].Value.ToString() + ";" + (m.Properties["EXPRESSION"].Value==null?"<echtes Measure>":"<berechnetes Measure>");
                tw.WriteLine(zeile);

                _erg.Text = "Measuregroup: " + measuregruppe + " Displayfolder:" + m.DisplayFolder + " Name:" + m.Caption + " Description: " + m.Properties["DESCRIPTION"].Value.ToString() + Environment.NewLine + _erg.Text;
            }

            tw.Close();
        }

        private ADOMD.CubeDef getCube(string cubename, ADOMD.AdomdConnection conn)
        {
            foreach (ADOMD.CubeDef c in conn.Cubes)
            {
                if (c.Name.ToUpper() == cubename.ToUpper())
                {
                    return c;
                }
            }
            return null;
        }
    }
}
